package de.janschejbal.p2pbluetoothtest.protocol.simple;

import java.io.IOException;
import java.util.Random;

import de.janschejbal.p2pbluetoothtest.protocol.base.ProtocolMessage;
import de.janschejbal.p2pbluetoothtest.protocol.base.SafeWriter;

public class RandomBodyMessage implements ProtocolMessage {
	private final int tag;
	private final int length;
	
	private final static Random fastRandom = new Random();
	
	public final static int MAX_LENGTH = 1024*1024;
		
	public RandomBodyMessage(int tag, int length) {
		this.tag = tag;
		this.length = length;
		if (length > MAX_LENGTH) throw new RuntimeException("Tried to create oversized message");
	}

	@Override
	public void send(SafeWriter sink) throws IOException {
		sink.writeHeader(tag, length);
		byte[] randomcrap = new byte[length];
		fastRandom.nextBytes(randomcrap);
		sink.write(randomcrap);
	}
}
