package de.janschejbal.p2pbluetoothtest.protocol.broadcast;

import java.io.IOException;

import de.janschejbal.p2pbluetoothtest.protocol.base.ProtocolException;
import de.janschejbal.p2pbluetoothtest.protocol.base.ProtocolMessage;
import de.janschejbal.p2pbluetoothtest.protocol.base.ProtocolMessageParser;
import de.janschejbal.p2pbluetoothtest.protocol.base.SafeReader;
import de.janschejbal.p2pbluetoothtest.protocol.base.SafeWriter;

public class FinishedMessage implements ProtocolMessage {
	/**
	 * Creates a new FinishedMessage (which is empty)
	 */
	public FinishedMessage() {
	}

	@Override
	public void send(SafeWriter sink) throws IOException {
		sink.writeHeader(BroadcastProtocolConnection.MESSAGE_FINISHED, 0);
	}

	private static final ProtocolMessageParser<FinishedMessage> parser = new ProtocolMessageParser<FinishedMessage>() {
		@Override
		public FinishedMessage parseMessage(int tag, int length, SafeReader source) throws IOException {
			if (tag != BroadcastProtocolConnection.MESSAGE_FINISHED) throw new ProtocolException("Tag mismatch");
			source.chompOverhang();
			return new FinishedMessage();
		}
	};

	public static ProtocolMessageParser<FinishedMessage> getParser() {
		return parser;
	}

}
